Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isAuto = exports.isHidden = exports.display = exports.percentage = undefined;

var _templateObject = _taggedTemplateLiteral(['display: ', ''], ['display: ', '']),
    _templateObject2 = _taggedTemplateLiteral(['display: block'], ['display: block']),
    _templateObject3 = _taggedTemplateLiteral(['\n      display: none;\n    '], ['\n      display: none;\n    ']),
    _templateObject4 = _taggedTemplateLiteral(['\n      flex: 1;\n    '], ['\n      flex: 1;\n    ']),
    _templateObject5 = _taggedTemplateLiteral(['\n      flex-basis: ', '%;\n      max-width: ', '%;\n      ', '\n    '], ['\n      flex-basis: ', '%;\n      max-width: ', '%;\n      ', '\n    ']),
    _templateObject6 = _taggedTemplateLiteral(['\n      width: ', ';\n      max-width: ', ';\n      flex-basis: initial;\n    '], ['\n      width: ', ';\n      max-width: ', ';\n      flex-basis: initial;\n    ']);

var _styledComponents = require('styled-components');

var _has = require('lodash/has');

var _has2 = _interopRequireDefault(_has);

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _theme = require('../../theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var theme = _theme.themeProvider.theme;
var percentage = exports.percentage = function percentage(props, breakpoint) {
  return Math.abs(props[breakpoint]) / theme(props).columns * 100;
};

var display = exports.display = function display(props, breakpoint) {
  if (props.display && (0, _isString2['default'])(props.display)) {
    return (0, _styledComponents.css)(_templateObject, props.display);
  }

  return !(0, _has2['default'])(props.display, '' + String(breakpoint)) ? (0, _styledComponents.css)(_templateObject2) : null;
};

var isHidden = exports.isHidden = function isHidden(props, breakpoint) {
  return props[breakpoint] === 0 || props[breakpoint] === 'hidden';
};

var isAuto = exports.isAuto = function isAuto(props, breakpoint) {
  return props[breakpoint] === 'auto';
};

var columnWidth = function columnWidth(props, breakpoint) {
  if (isHidden(props, breakpoint)) {
    return (0, _styledComponents.css)(_templateObject3);
  }

  if (isAuto(props, breakpoint)) {
    return (0, _styledComponents.css)(_templateObject4);
  }

  var width = percentage(props, breakpoint);

  if ((0, _has2['default'])(props, '' + String(breakpoint)) && typeof props[breakpoint] !== 'string') {
    return (0, _styledComponents.css)(_templateObject5, width, width, display(props, breakpoint));
  }

  if ((0, _has2['default'])(props, '' + String(breakpoint)) && typeof props[breakpoint] === 'string') {
    return (0, _styledComponents.css)(_templateObject6, props[breakpoint], props[breakpoint]);
  }

  return null;
};
exports['default'] = columnWidth;